// TestIO.cpp : implementation file
//

#include "stdafx.h"
#include "CK_PCI1230.h"
#include "TestIO.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestIO dialog


CTestIO::CTestIO(CWnd* pParent /*=NULL*/)
	: CDialog(CTestIO::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestIO)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_out		= 0;
	m_in		= 7;

	for( int i = 0; i <16; i++ )
	{
		m_outs[i] = 0;
		m_ins[i]  = 0;
	}

}


void CTestIO::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestIO)
	DDX_Control(pDX, IDC_CMDINT9, m_cmdIn[9]);
	DDX_Control(pDX, IDC_CMDINT8, m_cmdIn[8]);
	DDX_Control(pDX, IDC_CMDINT7, m_cmdIn[7]);
	DDX_Control(pDX, IDC_CMDINT6, m_cmdIn[6]);
	DDX_Control(pDX, IDC_CMDINT5, m_cmdIn[5]);
	DDX_Control(pDX, IDC_CMDINT4, m_cmdIn[4]);
	DDX_Control(pDX, IDC_CMDINT3, m_cmdIn[3]);
	DDX_Control(pDX, IDC_CMDINT2, m_cmdIn[2]);
	DDX_Control(pDX, IDC_CMDINT15, m_cmdIn[15]);
	DDX_Control(pDX, IDC_CMDINT14, m_cmdIn[14]);
	DDX_Control(pDX, IDC_CMDINT13, m_cmdIn[13]);
	DDX_Control(pDX, IDC_CMDINT12, m_cmdIn[12]);
	DDX_Control(pDX, IDC_CMDINT11, m_cmdIn[11]);
	DDX_Control(pDX, IDC_CMDINT10, m_cmdIn[10]);
	DDX_Control(pDX, IDC_CMDINT1, m_cmdIn[1]);
	DDX_Control(pDX, IDC_CMDINT0, m_cmdIn[0]);
	DDX_Control(pDX, IDC_CMDOUT9, m_cmdOut9);
	DDX_Control(pDX, IDC_CMDOUT8, m_cmdOut8);
	DDX_Control(pDX, IDC_CMDOUT7, m_cmdOut7);
	DDX_Control(pDX, IDC_CMDOUT6, m_cmdOut6);
	DDX_Control(pDX, IDC_CMDOUT5, m_cmdOut5);
	DDX_Control(pDX, IDC_CMDOUT4, m_cmdOut4);
	DDX_Control(pDX, IDC_CMDOUT3, m_cmdOut3);
	DDX_Control(pDX, IDC_CMDOUT2, m_cmdOut2);
	DDX_Control(pDX, IDC_CMDOUT15, m_cmdOut15);
	DDX_Control(pDX, IDC_CMDOUT14, m_cmdOut14);
	DDX_Control(pDX, IDC_CMDOUT13, m_cmdOut13);
	DDX_Control(pDX, IDC_CMDOUT12, m_cmdOut12);
	DDX_Control(pDX, IDC_CMDOUT11, m_cmdOut11);
	DDX_Control(pDX, IDC_CMDOUT10, m_cmdOut10);
	DDX_Control(pDX, IDC_CMDOUT1, m_cmdOut1);
	DDX_Control(pDX, IDC_CMDOUT0, m_cmdOut0);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestIO, CDialog)
	//{{AFX_MSG_MAP(CTestIO)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_CMDOUT0, OnCmdout0)
	ON_BN_CLICKED(IDC_CMDOUT15, OnCmdOut15)
	ON_BN_CLICKED(IDC_CMDOUT14, OnCmdOut14)
	ON_BN_CLICKED(IDC_CMDOUT13, OnCmdOut13)
	ON_BN_CLICKED(IDC_CMDOUT12, OnCmdOut12)
	ON_BN_CLICKED(IDC_CMDOUT11, OnCmdOut11)
	ON_BN_CLICKED(IDC_CMDOUT10, OnCmdOut10)
	ON_BN_CLICKED(IDC_CMDOUT9, OnCmdOut9)
	ON_BN_CLICKED(IDC_CMDOUT8, OnCmdOut8)
	ON_BN_CLICKED(IDC_CMDOUT7, OnCmdOut7)
	ON_BN_CLICKED(IDC_CMDOUT6, OnCmdOut6)
	ON_BN_CLICKED(IDC_CMDOUT5, OnCmdOut5)
	ON_BN_CLICKED(IDC_CMDOUT4, OnCmdOut4)
	ON_BN_CLICKED(IDC_CMDOUT3, OnCmdOut3)
	ON_BN_CLICKED(IDC_CMDOUT2, OnCmdOut2)
	ON_BN_CLICKED(IDC_CMDOUT1, OnCmdOut1)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestIO message handlers


void CTestIO::OnExit() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnOK();
}

BOOL CTestIO::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	bmp[0].LoadBitmap( IDB_OFF );
	bmp[1].LoadBitmap( IDB_ON );

	m_cmdOut0.SetBitmap( bmp[0] );
	m_cmdOut1.SetBitmap( bmp[0] );
	m_cmdOut2.SetBitmap( bmp[0] );
	m_cmdOut3.SetBitmap( bmp[0] );
	m_cmdOut4.SetBitmap( bmp[0] );
	m_cmdOut5.SetBitmap( bmp[0] );
	m_cmdOut6.SetBitmap( bmp[0] );
	m_cmdOut7.SetBitmap( bmp[0] );
	m_cmdOut8.SetBitmap( bmp[0] );
	m_cmdOut9.SetBitmap( bmp[0] );
	m_cmdOut10.SetBitmap( bmp[0] );
	m_cmdOut11.SetBitmap( bmp[0] );
	m_cmdOut12.SetBitmap( bmp[0] );
	m_cmdOut13.SetBitmap( bmp[0] );
	m_cmdOut14.SetBitmap( bmp[0] );
	m_cmdOut15.SetBitmap( bmp[0] );

	m_cmdIn[0].SetBitmap( bmp[0] );
	m_cmdIn[1].SetBitmap( bmp[0] );
	m_cmdIn[2].SetBitmap( bmp[0] );
	m_cmdIn[3].SetBitmap( bmp[0] );
	m_cmdIn[4].SetBitmap( bmp[0] );
	m_cmdIn[5].SetBitmap( bmp[0] );
	m_cmdIn[6].SetBitmap( bmp[0] );
	m_cmdIn[7].SetBitmap( bmp[0] );
	m_cmdIn[8].SetBitmap( bmp[0] );
	m_cmdIn[9].SetBitmap( bmp[0] );
	m_cmdIn[10].SetBitmap( bmp[0] );
	m_cmdIn[11].SetBitmap( bmp[0] );
	m_cmdIn[12].SetBitmap( bmp[0] );
	m_cmdIn[13].SetBitmap( bmp[0] );
	m_cmdIn[14].SetBitmap( bmp[0] );
	m_cmdIn[15].SetBitmap( bmp[0] );

	SetTimer( 0, 100, NULL );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CTestIO::GetSum( BOOL s[] )
{
	int count;
	int sum = 0;
	for( int i = 0; i < 16; i++ )
	{
		if( s[i] )
		{
			sum += pow( 2, i );
		}
	}

	return sum;
}

void CTestIO::OutPut()
{
	m_out = GetSum( m_outs );
	Pci1230Write( g_CardNo, m_out );
}

void CTestIO::InPut()
{
	int in;
	int i = 0;
	in = (int)m_in;

	while( i < 16 )
	{
		if( in & 0x01 )
		{
			m_ins[i] = TRUE;
		}
		else
		{
			m_ins[i] = FALSE;
		}

		i++;
		in = in >> 1;
	}

	for( i = 0; i < 16; i++ )
	{
		if( m_ins[i] )
		{
			m_cmdIn[i].SetBitmap( bmp[1] );
		}
		else
		{
			m_cmdIn[i].SetBitmap( bmp[0] );			
		}
	}

}


void CTestIO::OnCmdout0() 
{
	// TODO: Add your control notification handler code here
	m_outs[15] = !m_outs[15];
	if( m_outs[15] )
	{
		m_cmdOut0.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut0.SetBitmap( bmp[0] );
	}	

	OutPut();
}

void CTestIO::OnCmdOut15() 
{
	// TODO: Add your control notification handler code here
	m_outs[0] = !m_outs[0];
	if( m_outs[0] )
	{
		m_cmdOut15.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut15.SetBitmap( bmp[0] );
	}
	
	OutPut();
}

void CTestIO::OnCmdOut14() 
{
	// TODO: Add your control notification handler code here
	m_outs[1] = !m_outs[1];
	if( m_outs[1] )
	{
		m_cmdOut14.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut14.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut13() 
{
	// TODO: Add your control notification handler code here
	m_outs[2] = !m_outs[2];
	if( m_outs[2] )
	{
		m_cmdOut13.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut13.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut12() 
{
	// TODO: Add your control notification handler code here
	m_outs[3] = !m_outs[3];
	if( m_outs[3] )
	{
		m_cmdOut12.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut12.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut11() 
{
	// TODO: Add your control notification handler code here
	m_outs[4] = !m_outs[4];
	if( m_outs[4] )
	{
		m_cmdOut11.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut11.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut10() 
{
	// TODO: Add your control notification handler code here
	m_outs[5] = !m_outs[5];
	if( m_outs[5] )
	{
		m_cmdOut10.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut10.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut9() 
{
	// TODO: Add your control notification handler code here
	m_outs[6] = !m_outs[6];
	if( m_outs[6] )
	{
		m_cmdOut9.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut9.SetBitmap( bmp[0] );
	}
	
	OutPut();	
}

void CTestIO::OnCmdOut8() 
{
	// TODO: Add your control notification handler code here
	m_outs[7] = !m_outs[7];
	if( m_outs[7] )
	{
		m_cmdOut8.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut8.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut7() 
{
	// TODO: Add your control notification handler code here
	m_outs[8] = !m_outs[8];
	if( m_outs[8] )
	{
		m_cmdOut7.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut7.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut6() 
{
	// TODO: Add your control notification handler code here
	m_outs[9] = !m_outs[9];
	if( m_outs[9] )
	{
		m_cmdOut6.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut6.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut5() 
{
	// TODO: Add your control notification handler code here
	m_outs[10] = !m_outs[10];
	if( m_outs[10] )
	{
		m_cmdOut5.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut5.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut4() 
{
	// TODO: Add your control notification handler code here
	m_outs[11] = !m_outs[11];
	if( m_outs[11] )
	{
		m_cmdOut4.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut4.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut3() 
{
	// TODO: Add your control notification handler code here
	m_outs[12] = !m_outs[12];
	if( m_outs[12] )
	{
		m_cmdOut3.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut3.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut2() 
{
	// TODO: Add your control notification handler code here
	m_outs[13] = !m_outs[13];
	if( m_outs[13] )
	{
		m_cmdOut2.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut2.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnCmdOut1() 
{
	// TODO: Add your control notification handler code here
	m_outs[14] = !m_outs[14];
	if( m_outs[14] )
	{
		m_cmdOut1.SetBitmap( bmp[1] );
	}
	else
	{
		m_cmdOut1.SetBitmap( bmp[0] );
	}
	
	OutPut();		
}

void CTestIO::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	

	switch( nIDEvent )
	{
	case 0:
		{
			Pci1230Read( g_CardNo, &m_in );

			SetDlgItemInt( IDC_EDIT1, m_in );

			InPut();
			break;
		}
	}
	CDialog::OnTimer(nIDEvent);
}
